from Products.CMFCore.TypesTool import ContentFactoryMetadata
from Products.CMFCore.DirectoryView import addDirectoryViews
from Products.CMFPhotoAlbum import PhotoAlbum, photoalbum_globals
from Products.CMFCore.utils import getToolByName
from cStringIO import StringIO
import string

def register_type(self, out):
    typesTool = getToolByName(self, 'portal_types')
    for f in (PhotoAlbum.factory_type_information, ):
        if f['id'] not in typesTool.objectIds():
            cfm = apply(ContentFactoryMetadata, (), f)
            typesTool._setObject(f['id'], cfm)
            out.write('Registered with the types tool\n')
        else:
            out.write('Object "%s" already existed in the types tool\n' % (
                f['id']))

def install_skins(self, out):
    skinsTool = getToolByName(self, 'portal_skins')
    if 'photoalbum_content' not in skinsTool.objectIds():
        addDirectoryViews(skinsTool, 'skins', photoalbum_globals)
        out.write("Added 'photoalbum_content' directory views to portal_skins\n")

    skins = skinsTool.getSkinSelections()
    for skin in skins:
        path = skinsTool.getSkinPath(skin)
        path = map(string.strip, string.split(path,','))
        if 'photoalbum_content' not in path and skin.startswith('Plone'):
            path.append('photoalbum_content')
            path.append('photoalbum_scripts')

            path = string.join(path, ', ')
            skinsTool.addSkinSelection(skin, path)
            out.write("Added 'photoalbum_content' to %s skins\n" % skin)
        else:
            out.write('Skipping %s skin\n' % skin)

def removeSkin(self, out):
    skinsTool = getToolByName(self, 'portal_skins')

    skins = skinsTool.getSkinSelections()
    for skin in skins:
        path = skinsTool.getSkinPath(skin)
        path = map(string.strip, string.split(path,','))
        if 'photoalbum_content' or 'photoalbum_scripts' in path:
            path.remove('photoalbum_content')
            path.remove('photoalbum_scripts')
            path = string.join(path, ', ')
            skinsTool.addSkinSelection(skin, path)

    if 'photoalbum_content' or 'photoalbum_scripts' in skinsTool.objectIds():
        skinsTool._delObject('photoalbum_content','photoalbum_scripts')
        out.write('Removed skins from the portal_skins\n')

def remove_types(self, out):
    typesTool = getToolByName(self, 'portal_types')

    for f in (PhotoAlbum.factory_type_information, ):
        if f['id'] not in typesTool.objectIds():
            cfm = apply(ContentFactoryMetadata, (), f)
            typesTool._delObject(f['id'], cfm)
            out.write('Removed type Photo Album from portal_types\n')

def install(self):
    """ """

    out = StringIO()
    register_type(self, out)
    install_skins(self, out)
    out.write ('Installation completed.\n')
    return out.getvalue()

def uninstall (self):
    out = StringIO ()

    removeSkin (self, out)
    remove_types(self, out)
    out.write ('Uninstallation completed.\n')
    return out.getvalue()

